
double pdist(int Ax, int Ay,int Bx,int By)
{
  By-= Ay; Bx-= Ax;
  return sqrt(By*By+Bx*Bx);
}

static image_t *CCimage;

int prtneigh(uint8_t *S,int x,int y)
{
  int dx,dy;
  for(dy=-1;dy<=1;dy++)
  {
    if (y+dy<0) continue; if (y+dy>=CCimage->h) continue;
    for(dx=-1;dx<=1;dx++)
    {
      if (x+dx<0) continue; if (x+dx>=CCimage->w) continue;
      if (S[(x+dx)+(y+dy)*CCimage->w]) printf("X"); else printf(".");
    }
   printf("\n");
  }
  return 1;
}


int get_maxdist_pair
   (uint8_t *S, int W, int H, int *rAX, int *rAY, int *rBX, int *rBY)
{
  int i,sz, Ax,Ay,Bx,By,Cx,Cy,Dx,Dy,t; 
  int dx,dy,dxS,dxE,dyS,dyE;
  double D,K,M;
  int fail;

  sz= W*H;
  for(i=0;i<sz;i++) if (S[i]) break;
  if (i==sz) { printf("no pixels\n"); return 1; }
  Ax= i%W; Ay= i/W;
//  for(i++;i<sz;i++) if (S[i]) break;
  for(i=sz-1;i>=0;i--) if (S[i]) break;
  Bx= i%W; By= i/W;

  int col=1;

  
 
  mark_point(CCimage,Ax,Ay,1-col);
  mark_point(CCimage,Bx,By,col);

  D= pdist(Ax,Ay,Bx,By);
  fail= 0;
  while(1)
  {
    M= 0;
    dyS= -1; dyE= 1; if (By==0) dyS=0; if (By==H-1) dyE=0;
    dxS= -1; dxE= 1; if (Bx==0) dxS=0; if (Bx==W-1) dxE=0;

    for(dy=dyS;dy<=dyE;dy++)
     for(dx=dxS;dx<=dxE;dx++)
    {
       if (dx==0 && dy==0) continue;
       Dx= Bx+dx; Dy= By+dy;
       if (!S[Dx+Dy*W]) continue; 
       K= pdist(Ax,Ay,Dx,Dy);
       if (K>M) { M=K; Cx= Dx; Cy= Dy;  }
    }

    if (M<=D)
    {
      fail++;
      if (fail==2) break;
      t= Ax; Ax= Bx; Bx= t;
      t= Ay; Ay= By; By= t;
      col= 1-col;
    }
    else
    {
      D= M;
      Bx= Cx; By= Cy;
      fail= 0;
      mark_point(CCimage,Bx,By,col);
    }
  }

  *rAX= Ax; *rAY= Ay; *rBX= Bx; *rBY= By;

  return 0;
}

int find_normal_intersect
  (uint8_t *S,int W,int H,int X0,int Y0,int X1,int Y1,int *rX2,int *rY2)
{
  int mX,mY,dX,dY; 
  int E, Eth, Esq, Edi; // error variable and constants for bresenham line
  int pX, pY; // current point and point update vector
  int adX, adY;
  int dXsq, dYsq, dXdi, dYdi; // square and diagonal updates
  int fX, fY; // found X, Y
  int found,count;  // found flag, count is used to travel in each direction
                    // once

  // these two define the slope of the normal, not the chord
  dY= -X1+ X0; dX=  Y1- Y0;
   // mid-point X and Y, this is the starting point
  mX= (X1+X0)/2; mY= (Y1+Y0)/2;

  adX= abs(dX); adY= abs(dY);
  if (adX>=adY)
  {
    Eth= adX-2*adY; Edi= -2*adX; Esq= 2*adY;
      // we update X on square moves, but not when error exceeds threshold
    dXsq= 1;  dXdi= 0; dYsq= 0;
    if (dX<0) { dX= -dX; dY= -dY; }
    if (dY<0) dYdi= -1; else dYdi= 1;
  }
  else
  {
    Eth= adY-2*adX; Edi= -2*adY; Esq= 2*adX;
    dYsq= 1; dYdi= 0; dXsq= 0;
    if (dY<0) { dY= -dY; dX= -dX; }
    if (dX<0) dXdi= -1; else dXdi= 1;
  }

  count= 0;
again:
  found= 0;
  if (count==2) return 1;

  pX= mX; pY= mY; E= 0;
  while(pX>=0 && pX<W && pY>=0 && pY<H)
  {
    if (S[pX+pY*W]) { fX= pX; fY= pY; found= 1; }
    if (E>Eth) { pX+= dXdi; pY+= dYdi; E+= Edi; }
    E+= Esq; pX+= dXsq; pY+= dYsq;
  }
  if (!found)
    { dXsq *= -1; dYsq *= -1; dXdi *= -1; dYdi *= -1; count++; goto again; }
  
  *rX2= fX; *rY2= fY;
  return 0;
}

int circpix(uint8_t *S,int W,int H, int x,int y)
{
  if (x<0 || y<0 || x>=W || y>=H) return 0;
  return S[x+y*W];
}

void circdrapix(uint8_t *D,int W,int H,int x,int y)
{
  if (x<0 || y<0 || x>=W || y>=H) return ;
  D[x+y*W]= 0xFF; 
}

int test_circle(uint8_t *S,int W,int H, int cX,int cY, int r)
{
  int count;
  // from http://members.chello.at/~easyfilter/bresenham.html
  int x = -r, y = 0, err = 2-2*r;
  count= 0;
  do {
    count+= circpix(S,W,H,cX-x, cY+y); /*   I. Quadrant */
    count+= circpix(S,W,H,cX-y, cY-x); /*  II. Quadrant */
    count+= circpix(S,W,H,cX+x, cY-y); /* III. Quadrant */
    count+= circpix(S,W,H,cX+y, cY+x); /*  IV. Quadrant */
    r = err;
    if (r <= y) err += ++y*2+1;           /* e_xy+e_y < 0 */
    if (r > x || err > y) err += ++x*2+1; /* e_xy+e_x > 0 or no 2nd y-step */
  } while (x < 0);
  return count;
}

void draw_circle(uint8_t *D,int W,int H, int cX,int cY, int r)
{
  // from http://members.chello.at/~easyfilter/bresenham.html
  int x = -r, y = 0, err = 2-2*r;
  do {
    circdrapix(D,W,H,cX-x, cY+y); /*   I. Quadrant */
    circdrapix(D,W,H,cX-y, cY-x); /*  II. Quadrant */
    circdrapix(D,W,H,cX+x, cY-y); /* III. Quadrant */
    circdrapix(D,W,H,cX+y, cY+x); /*  IV. Quadrant */
    r = err;
    if (r <= y) err += ++y*2+1;           /* e_xy+e_y < 0 */
    if (r > x || err > y) err += ++x*2+1; /* e_xy+e_x > 0 or no 2nd y-step */
  } while (x < 0);
}

int circle3points(int X0,int Y0,int X1,int Y1,int X2,int Y2,
                  int *rP, int *rQ, int *rR)
{
  double A0,A1,A2, B0,B1,B2, C0,C1,C2, D0,D1, E0,E1, K0,K1;
  double t, M, p, q, r;
  A0= 2*X0;   B0= 2*Y0;   C0= X0*X0+Y0*Y0;
  A1= 2*X1;   B1= 2*Y1;   C1= X1*X1+Y1*Y1;
  A2= 2*X2;   B2= 2*Y2;   C2= X2*X2+Y2*Y2;

  D0= 2*A0-A1-A2;  E0= 2*B0-B1-B2; K0= 2*C0-C1-C2;
  D1= 2*A1-A0-A2;  E1= 2*B1-B0-B2; K1= 2*C1-C0-C2;

  if (E0==0 || E1==0) return 1;
  
  t= E0/E1;
  M= K0 - t*K1;
  if (D0==D1*t) return 1;
  p= M / (D0-D1*t);
  q= (K0-D0*p)/E0;
  r= sqrt( (X0-p)*(X0-p)+(Y0-q)*(Y0-q) );

  *rP= p; *rQ= q; *rR= r;
  return 0;
}

void find_circle()
{
  int W,H; uint8_t *S;
  int X0,X1,X2, Y0,Y1,Y2;
  int Px, Py;
  image_t *img;
  int i,sz;
  image_t *oi;
  image_t *i2;
  int cX, cY, R;

  if (!cimage || cimage->type!='g') return ;
  W= cimage->w;
  H= cimage->h;
  S= cimage->bdata;

  img= image_new('g', cimage);

  oi= cimage;
  CCimage= img;

  sz= W*H;
  for(i=0;i<sz;i++) img->bdata[i]= S[i]>>1;

  if (get_maxdist_pair(S,W,H, &X0, &Y0, &X1, &Y1)) goto put1done;
  Px= (X0+X1)/2; Py= (Y0+Y1)/2;
  img->bdata[Px+Py*W]= 0xFF;
  img->bdata[X0+Y0*W]= 0xFF;
  img->bdata[X1+Y1*W]= 0xFF;

  if (find_normal_intersect(S,W,H,X0,Y0,X1,Y1,&X2,&Y2)) goto put1done;
  img->bdata[X2+Y2*W]= 0xFF;

  if (circle3points(X0,Y0,X1,Y1,X2,Y2, &cX, &cY,&R)) goto put1done;

  int bv= 0, bx, by, br, dx, dy, dr, x,y,r,v;

  for(dy=-1;dy<2;dy++) for(dx=-1;dx<2;dx++) for(dr=-1;dr<2;dr++)
  {
     x= dx+cX; y= dy+cY; r= dr+R;
     v= test_circle(S,W,H, x,y,r);
 printf("(%d, %d, %d)= %d\n", x,y,r, v);
     if (v>bv) { bv= v; bx= x; by= y; br= r; }
  }
  if (bv==0) goto put1done;

  int N, T;
  N= T= 0;
  for(i=0;i<sz;i++)
    if (S[i]) { N++; T+= abs(pdist(i%W,i/W,bx,by)-r); }

  if (N!=0) printf("average error: %f\n", (double)T/N);
 
  i2= image_new('g',img);
  draw_circle(i2->bdata,W,H, bx, by, br);
  printf("circle: (%d,%d,%d)\n", bx,by,br);
  put_image_in_list(img, oi, "circle-find", "");
  put_image_in_list(i2, img, "circle-draw", "");
  return ;

put1done:
  put_image_in_list(img, oi, "circle", "");
  return ;
}


