


typedef struct
{
  int N;
  double *data; 
  char *name;
} convo_t;

convo_t* convo_new(int N)
{
  convo_t *C;
  C= malloc(sizeof(*C));
  C->N= N;
  C->data= malloc(sizeof(double)*N*N);
  C->name= NULL;
  return C;
}

void convolve_image(convo_t *CM)
{
  image_t *img;
  int x,y,fx,fy; double WS,VS, weight; int W,H,C;
  if (!cimage || cimage->type!='g') return ;
  img= image_new('g', cimage);

  W= img->w; H= img->h; C= CM->N/2;
  for(y=0;y<H;y++)
    for(x=0;x<W;x++)
    {
      VS= WS= 0;
      for(fy=-C;fy<=C;fy++)
       for(fx=-C;fx<=C;fx++)
        if ((x+fx)>=0 && (x+fx)<W && (y+fy)>=0 && (y+fy)<H)
        {
          weight= CM->data[ (fy+C)*CM->N + (fx+C) ];
          WS += weight;
          VS += cimage->bdata[(x+fx)+(y+fy)*W]*weight;
        }
      if (WS)
      {
        int P= VS/WS; if (P<0) P= 0; if (P>255) P= 255;
        img->bdata[x+y*W]= P;
      }
      else 
        img->bdata[x+y*W]= 0;
    }
  put_image_in_list(img, cimage, "apply", CM->name);
}

