

static double gaussian(double x, double y, double rho)
{
  return M_1_PI*(1/2.0)*(1/(rho*rho))*exp( - (x*x+y*y)/(2*rho*rho) );
}


static double gauss_at_pixel(int x,int y, double rho)
{
  double px, py;
  double sum;
  sum= 0.0;
#define delta 0.001
  for(py=y-0.5;py<y+0.5;py+=delta)
    for(px=x-0.5;px<x+0.5;px+=delta)
      sum += gaussian(px, py, rho);
  return sum*delta*delta;
#undef delta
}

convo_t *gaussian_filter(char *Ntxt, char *rhotxt)
{
  int x,y,C;
  int i;
  double *G;
  convo_t *CC;
  int N;double rho;
  char buf[200];

  if (Ntxt[0]) N= atoi(Ntxt); else { N= 5; Ntxt= "5"; }
  if (rhotxt[0]) rho= strtod(rhotxt,NULL); else { rho= 1.0; rhotxt= "1.0"; }
  
  sprintf(buf,"gauss(%s,%s)", Ntxt, rhotxt);

  C= N/2;
  rho= 1;
  G= malloc(N*N*sizeof(double));
  CC= malloc(sizeof(*CC));
  CC->name= strdup(buf);
  CC->N= N;

  i= 0;
  for(y=-C;y<=C;y++) 
    for(x=-C;x<=C;x++)
      G[i++]= gauss_at_pixel(x,y,rho);

  CC->data= G;
  return CC;
}

