

void convert_gray(char *rtxt, char *gtxt, char *btxt)
{
  double coeff[3];
  char *cotex;
  char buf[200];
  image_t *img;
  int x,y;
  if (!cimage || cimage->type!='R') return ;
  if (!rtxt[0] || !gtxt[0] || !btxt[0])
  {
    coeff[0]= 0.29; coeff[1]= 0.59; coeff[2]= 0.12;
    cotex= "0.29,0.59,0.12";
  }
  else
  {
    coeff[0]= strtod(rtxt, NULL);
    coeff[1]= strtod(gtxt, NULL);
    coeff[2]= strtod(btxt, NULL);
    sprintf(buf,"%s,%s,%s",rtxt,gtxt,btxt);
    cotex= buf;
  }
  img= image_new('g', cimage);
  for(y=0;y<img->h;y++)
   for(x=0;x<img->w;x++)
   {
      double GG;
      int R, G, B; unsigned int P;
      P= cimage->idata[x+y*img->w];
      R= (P>>16)&0xff;
      B= (P) & 0xff;
      G= (P>>8) & 0xff;
      GG= R * coeff[0] + G*coeff[1] + B*coeff[2];
      if (GG<0) GG= 0; 
      if (GG>255) GG= 255;
      img->bdata[x+y*img->w]= GG;
   }
  put_image_in_list(img, cimage, "gray", cotex);
}


