
#define iceil(X,Y)  (((X)+(Y)-1)/(Y))

#define ExtPercent  20

void genmask(char *PRn, char *PRt)
{
  int x,y,bx,by, W,H;
  unsigned char *S;
  unsigned char *D;
  image_t *img;
  char buf[200];
  int N, thr, sum,np;
  uint8_t *blk;
  int bW, bH;
  int minX, minY,maxX, maxY;
  int extW, extH;

  if (!cimage || cimage->type!='g') return ;
  if (!PRn || !PRn[0]) PRn= "16"; 
  if (!PRt || !PRt[0]) PRt= "120";
  N= atoi(PRn); if (N<2 || N>=cimage->w) N= 16;
  thr= atoi(PRt); if (thr<0 || thr>255) thr= 120;

  img= image_new('g',cimage);
  W= img->w; H= img->h; 
  bW= iceil(W,N); bH= iceil(H,N);
  blk= calloc(1,bW*bH);

  S= cimage->bdata;

  minX= W; maxX= 0; minY= H; maxY= 0;

  for(by=0;by<bH;by++)
    for(bx=0;bx<bW;bx++)
    {
      np= 0;
      sum= 0;
      for(y=0;y<N && (y+by*N)<H;y++)
        for(x=0;x<N && (x+bx*N)<W;x++)
          { np++; sum += S[(x+bx*N)+(y+by*N)*W]; }
      if (np) sum/= np; 
      if (sum<thr) sum= 0;
      else
      {
        if (minX>bx) minX= bx;
        if (maxX<bx) maxX= bx;
        if (minY>by) minY= by;
        if (maxY<by) maxY= by;
        sum= 0xff;
      }
      blk[bx+by*bW]= sum;
    }


  minX= minX*N; maxX= maxX*N+N-1;
  minY= minY*N; maxY= maxY*N+N-1;

  extW= (maxX-minX+1)*ExtPercent/100;
  extH= (maxY-minY+1)*ExtPercent/100;

  minX -= extW; if (minX<0) minX= 0;
  maxX += extW; if (maxX>=W) maxX= W-1;
  minY -= extH; if (minY<0) minY= 0;
  maxY += extH; if (maxY>=H) maxY= H-1;

  D= img->bdata; 

  for(y=minY;y<=maxY;y++)
    for(x=minX;x<=maxX;x++)
    {
#if 0
      for(y=0;y<N && (y+by*N)<H;y++)
        for(x=0;x<N && (x+bx*N)<W;x++)
          { D[(x+bx*N)+(y+by*N)*W]= 0xff; } // blk[bx+by*bW]; 
#endif
      D[x+y*W]= 0xff; 
    }

  img->subtype= 'M';
  img->iV[0]= minX; img->iV[1]= maxX; 
  img->iV[2]= minY; img->iV[3]= maxY; 

  sprintf(buf,"N=%d,thr=%d",N,thr);
  put_image_in_list(img, cimage, "genmask", buf);
}

image_t* subimage(image_t *simg,int sX,int sY, int dW, int dH)
{
  image_t *img; int x,y,sW;
  unsigned int *sI,*dI; unsigned char *sB, *dB;
  img= image_new_dim(simg->type, dW, dH);
  sW= simg->w; 
  
  if (simg->type=='R')
  {
    sI= simg->idata; dI= img->idata;
    for(y=0;y<dH;y++) for(x=0;x<dW;x++)
      dI[x+y*dH]= sI[(x+sX)+(y+sY)*sW ];
  }
  else
  {
    sB= simg->bdata; dB= img->bdata;
    for(y=0;y<dH;y++) for(x=0;x<dW;x++)
      dB[x+y*dH]= sB[(x+sX)+(y+sY)*sW ];
  }
  return img;
}


void applymask()
{
  image_t *img;
  if (!bgimage || !cimage || cimage->subtype!='M') return ;
  
  img= subimage(bgimage, cimage->iV[0], cimage->iV[2],
                         cimage->iV[1]-cimage->iV[0]+1,
                         cimage->iV[3]-cimage->iV[2]+1);

  put_image_in_list(img, bgimage, "mask", "");
}

