#include <stdlib.h>
#include <stdio.h>
#include "pngio.h"

int subc(int A,int B)
{
  if (A>B) return A-B;
  return B-A;
}

#define rgb(R,G,B) (0xFF000000 | ((R)<<16) | ((G)<<8) | (B))
#define RED(X) (((X)>>16)&0xff)
#define GRE(X) (((X)>>8)&0xff)
#define BLU(X) (((X)>>0)&0xff)

int main(int argc,char **argv)
{
  int i;
  unsigned int *I1,*I2,W1,W2,H1,H2;
  int sz;
  char *e;

  e= read_png_image(argv[1],&W1,&H1,&I1);
  if (e) exit(fprintf(stderr,"can't read %s: %s\n",argv[1],e));
  e= read_png_image(argv[2],&W2,&H2,&I2);
  if (e) exit(fprintf(stderr,"can't read %s: %s\n",argv[2],e));

  if (W1!=W2 || H1!=H2)
    exit(fprintf(stderr,"image sizes must be the same\n"));

  sz= W1*H1;
  for(i=0;i<sz;i++)
  {
     I1[i]= rgb( subc(RED(I1[i]), RED(I2[i])),
                 subc(GRE(I1[i]), GRE(I2[i])),
                 subc(BLU(I1[i]), BLU(I2[i])));
  }
  e= write_png_image(argv[3], W1,H1,I1);
  if (e) exit(fprintf(stderr,"can't read %s: %s\n",argv[3],e));
  return 0;
}
